@echo off

if /i "%PROCESSOR_ARCHITECTURE%%PROCESSOR_ARCHITEW6432%" == "x86" (goto RUN_X86) else (goto RUN_X64)

:RUN_X86
if not exist "%~dp0dpinst_x86.exe" call ::EXIT_AND_RETURN 2
start "%~dp0dpinst_x86.exe" /wait "%~dp0dpinst_x86.exe" /sw /se /sa /f
goto DRIVER_SETUP

:RUN_X64
if not exist "%~dp0dpinst_x64.exe" call ::EXIT_AND_RETURN 2
start "%~dp0dpinst_x64.exe" /wait "%~dp0dpinst_x64.exe" /sw /se /sa /f
goto DRIVER_SETUP

:DRIVER_SETUP
set RETURN=%ERRORLEVEL%
if %RETURN% equ -2147483648 set RETURN=0x80000000
set /a ZZ="(%RETURN% & 0x000000ff)"
set /a YY="(%RETURN% & 0x0000ff00) >> 8"
set /a XX="(%RETURN% & 0x00ff0000) >> 16"
set /a WW="(%RETURN% & 0xff000000) >> 24"
if %WW% lss 0 set /a WW+=256

if %ZZ% gtr 0 call :EXIT_AND_RETURN 0
if %YY% gtr 0 call :EXIT_AND_RETURN 0
call :EXIT_AND_RETURN 1

:EXIT_AND_RETURN
exit %1
